/**
*  type_contains_type(+OuterType, ?InnerType)
*  succeeds iff type with ID Arg1 contains a inner type with ID Arg2,  search is done transitive.
*/
type_contains_type_transitive(OuterType, InnerType) :-
   type_contains_type(OuterType, InnerType).

type_contains_type_transitive(OuterType, LocalClass) :-
   type_contains_method(OuterType, Method),
   method_contains_localclass(Method, LocalClass).
   
type_contains_type_transitive(OuterType, InnerType) :-
   type_contains_type(OuterType, Type),
   type_contains_type_transitive(Type, InnerType).

type_contains_type_transitive(OuterType, InnerType) :-
   type_contains_method(OuterType, Method),
   method_contains_localclass(Method, LocalClass),
   type_contains_type_transitive(LocalClass, InnerType).
