:- set_prolog_flag(  toplevel_print_options, [quoted(true), portray(true), max_depth(50), attributes(portray)] ).

cultivate_basic_location_fact.

set_file_search_path(Alias,Path) :- 
    ground((Alias,Path)),
    retractall(user:file_search_path(Alias,_)),
    assert(user:file_search_path(Alias,Path)).

set_cultivate_path :-
	cultivate_basic_location_fact,  
	not( user:file_search_path(cultivate_basic,_) )
    -> ( predicate_property(cultivate_basic_location_fact, file(File)),
	     file_directory_name(File,ThisProjectPath),
	     atom_concat(RootPath, '/cultivate.basic/prolog', ThisProjectPath),
         set_file_search_path(cultivate_basic,ThisProjectPath),
         assert(user:cultivate_root(RootPath))
     
       )
    ;  true.



:- set_cultivate_path.


 
	
:- use_module(types/load).
:- use_module(containment/load).
:- use_module(constants/load).
:- use_module(fields/load).
:- use_module(math/load).
:- use_module(methods/load).
:- use_module(misc/load).
:- use_module(naming/load).
:- use_module(packages/load).
:- use_module(structures/load).
:- use_module(util/load).
:- use_module(statements/load).


% Non-modules from here
:- consult(caching/load).
:- consult(aop/load). 
:- consult(smells/load).
:- consult(metrics/load).
:- consult(quantity/load).
