:- multifile query_description/3.
:- multifile metric_/3.
:- multifile metric_attributes/2.

query_description(numberOfTypes, metric, 'number of classes').
metric_attributes(numberOfTypes, int(range(0,infinity), defaultthresholds(0,infinity))).

      
/** *****************************************************************
  * Metric:  numberOfTypes
  * Return:  ?Integer
  * Context: ?PackageId, ?PackageName
  *
  * Returns the number of classes in the package PackageId/PackageName.
  * For external packages the predicate fails.
  */
metric_(numberOfTypes, PackageID, NumberOfTypes) :-
    internal_package(PackageID),
    number_of_types(PackageID,NumberOfTypes).
/**
*  number_of_types(+PackageID,?NumberOfTypes)
*  succeeds if package with ID Arg1 contains Arg2 many types
**/       
number_of_types(PackageID,NumberOfTypes) :-
	  count(ClassID,
        ( package_contains_type(PackageID, ClassID), 
          classT(ClassID, _, _, _)
        % not(interfactT(ClassID)) - Interfaces should be excluded in the future.
        % class(ClassID) JTransformer has its own conflicting definition of class/1
        ),
      NumberOfTypes
     ).      