:- multifile query_description/3.
:- multifile smell_/2.

 
query_description(forTestersOnly, smell,'method only called by tests').
  
smell_(forTestersOnly,MethodID) :-
    packageT(PackageID,_),
    ri_compilationUnitT_parent(PackageID, CompilationUnit),
	ri_classT_parent(CompilationUnit, ClassID),    
    not(externT(ClassID)),
    not(interfaceT(ClassID)),
    not(test_class(ClassID)),
    ri_methodT_parent(ClassID,MethodID),
    not(constructor(MethodID)),
    for_testers_only(MethodID).
 
/** for_testers_only(+MethodID)
  *
  * Returns all MethodIDs that are used inside of testMethods only.
  * Transform:
  * Return all MethodIDs that are NOT used outside of testMethods.
  * NOT Return all MethodIDs that are used outside of testMethods.
  */
for_testers_only(MethodID) :- 
	not(method_is_overriding(MethodID)),
	not(is_implementing(MethodID)),
	
	method_calls_method(Caller,MethodID),    
    is_test_method(Caller),
    !,

    not((
	  	method_calls_method(OtherCaller,MethodID),
      	OtherCaller \= MethodID,
      	not(is_test_method(OtherCaller))
    )).  
    