/**
* can_access_class(+ClassID, +AccessedClassID)
*
* checks if accessed class is visible/accessible for the other class
*/
can_access_class(_, AccessedClassID) :-
    ground(AccessedClassID),
	modifierT(AccessedClassID, public).

%both classes are in same package
can_access_class(ClassID, AccessedClassID) :-
    ground([ClassID, AccessedClassID]),
	modifierT(AccessedClassID, protected),
	innerclass_of(AccessedClassID, OuterClassID, direct),
    same_package(ClassID, OuterClassID).

%both classes are in same package
can_access_class(ClassID, AccessedClassID) :-
    ground([ClassID, AccessedClassID]),
    visibility(AccessedClassID, package),
    same_package(ClassID, AccessedClassID).

%class2 is (direct) inner class of class1
can_access_class(ClassID, AccessedClassID) :-
    ground([ClassID, AccessedClassID]),
    innerclass_of(AccessedClassID, ClassID, direct).

