/**
* can_access_field(+ClassID, +FieldID)
*
* checks if class can access field (if field is visible for class)
*/
%class contains field
can_access_field(ClassID, FieldID) :-
    ground([ClassID, FieldID]),
    fieldT(FieldID, ClassID, _, _, _).

%public field
can_access_field(ClassID, FieldID) :-
    ground([ClassID, FieldID]),
    modifierT(FieldID, public),
    fieldT(FieldID, OwnerClassID, _, _, _),
    can_access_class(ClassID, OwnerClassID).

%protected fields (same package)
can_access_field(ClassID, FieldID) :-
    ground([ClassID, FieldID]),
    modifierT(FieldID, protected),
    fieldT(FieldID, OwnerClassID, _, _, _),
    same_package(ClassID, OwnerClassID),
    can_access_class(ClassID, OwnerClassID).

%protected fields (subclasses)
can_access_field(ClassID, FieldID) :-
    ground([ClassID, FieldID]),
    modifierT(FieldID, protected),
    fieldT(FieldID, OwnerClassID, _, _, _),
    real_subtype(ClassID, OwnerClassID).

%package fields
can_access_field(ClassID, FieldID) :-
    ground([ClassID, FieldID]),
    field_access(FieldID, package),
    fieldT(FieldID, OwnerClassID, _, _, _),
    same_package(ClassID, OwnerClassID),
    can_access_class(ClassID, OwnerClassID).
    
