%%% designator(?Interface) 
%% succeeds iff Interface is an interface with absolutely no members. 
%%
%% The most trivial interface is an empty one. Interestingly,
%% vacuous interfaces are employed in a powerful programming
%% technique, of tagging classes in such a way that these tags can be
%% examined at runtime.
designator(Interface):- 
    	classT(Interface,_,_,_),
   		is_interface(Interface),
    	not(type_contains_method(Interface, _)).


/**
Thus, a Designator micro pattern is an interface which does not declare
any methods, does not define any static fields or methods, and
does not inherit such members from any of its superinterfaces.
A class can also be Designator if its definition, as well as the definitions
of all of its ancestors (other than Object), are empty.
**/    	