:- multifile termmetric/4.
:- multifile query_description/3.

query_description(term_idf,termmetric, 'Returns two list with the terms and their corresponding nr of occurence').

/** 
*  termmetric_(termfrequency,+Scope, -ContextID , -TermFrequencies)
*  Returns the term frequencies for the given scope, scope can be packageT,classT,methodDef
*  The returned list contains also if a term is introduced in this context.
*    T
**/
termmetric(term_idf,Scope, ContextID , TermIDF) :-
   once(term_metrics:metric_precondition),
   ast_node_type_value(ContextID,Scope), 
   not(externT(ContextID)), 
   term_idf_query__(ContextID, TermIDF).    

/**
* term_idf_query__(+Context, -TermIDF)
* Returns all term IDF for the given context Id. 
* Additionally this contains if a term is introduced in this context.
**/   
term_idf_query__(Context, TermIDF) :-
   findall( 
        [Term, TermIDF, IsIntroducedInContext],
        (cached_term_metrics_idf(Context,Term,TermIDF),
         is_term_introduced(Context,Term, IsIntroducedInContext)),
       TermIDF
   ).
  