% ================================================================
generate_ig_term_occurrence_counters__ :-
    clear_counters__,
    generate_counters__,
    generate_total_counters__.

clear_counters__:-
	retractall( cultivate_concepts_term_counts:term_occurrences_in_context(_,_,_,_)),
    retractall( cultivate_concepts_term_counts:term_counts_in_context(_,_,_)),
    retractall( cultivate_concepts_term_counts:cached_occurrences_of_term_in_context(_,_,_)),
    retractall( cultivate_concepts_term_counts:cached_occurrences_of_all_terms_in_context(_,_)).
    	    

generate_counters__ :-
    relevant_context_element(Context), 
    cultivate_concepts_term_cache:context_has_lexical(Context, TermId),
    cultivate_concepts_term_cache:lexical_term(TermId,Term),
  %  not(cultivate_concepts_term_counts:cached_occurrences_of_term_in_context(Context,Term,_)),
    count_occurrences_of_term_in_context(Context,interface,Term,InterfaceLevelCount),
    count_occurrences_of_term_in_context(Context,behavior,Term,BehaviorLevelCount),
    Count is InterfaceLevelCount + BehaviorLevelCount,
       assert_unique( cultivate_concepts_term_counts:cached_occurrences_of_term_in_context(Context,Term,Count)),
       assert_unique( cultivate_concepts_term_counts:term_occurrences_in_context(Context,interface,Term,InterfaceLevelCount) ),
       assert_unique( cultivate_concepts_term_counts:term_occurrences_in_context(Context,behavior,Term,BehaviorLevelCount) ),
   fail.
generate_counters__.

% count_occurrences_of_term_in_context(+Context,+Level, +Term, -Count)
% Counts the occurrences of the term in the given context e.g. 'get'  in a class
% level can be external, interface, behavior	
count_occurrences_of_term_in_context(Context,Level, _, Count) :-
    count( (context_has_lexical(Context,Id),classify_term(Id,Level)) , Count).
           
    
generate_total_counters__ :-
   relevant_context_element(Context), 
   count_occurrences_of_all_terms_in_context__(Context, interface,CountOfAllTermsInInterfaceContext),
   count_occurrences_of_all_terms_in_context__(Context, behavior,CountOfAllTermsInbehaviorContext),
   CountOfAllTermsInContext is CountOfAllTermsInInterfaceContext + CountOfAllTermsInbehaviorContext,
     assert_unique( cultivate_concepts_term_counts:cached_occurrences_of_all_terms_in_context(Context,CountOfAllTermsInContext) ),
     assert_unique( cultivate_concepts_term_counts:term_counts_in_context(Context,interface,CountOfAllTermsInInterfaceContext) ),
     assert_unique( cultivate_concepts_term_counts:term_counts_in_context(Context,behavior,CountOfAllTermsInbehaviorContext) ),
   fail.
generate_total_counters__.


count_occurrences_of_all_terms_in_context__(Context,Level, CountOfAllTermsInContext):-
   findall(Count,
          cultivate_concepts_term_counts:term_occurrences_in_context(Context,Level,_,Count),
          OccurenceList),
   sumall( OccurenceList,CountOfAllTermsInContext).  
	    
    