:- multifile query_description/3.

/**
*  package_circularity(-Packages,-Dependencies)
*  True if Arg2 is a List of Packages on which Arg1 is depending.
*/
package_circularity(Packages,Dependencies) :-
    	packageDependency(DepList),
    	
   	    findall(	SccNumber,
             		member([_,_,SccNumber,_],DepList),
             		SccNumberListWithDuplicates),	    
	    sort(SccNumberListWithDuplicates,SccNumberList),
    	
    	!,

		member(SccNumber2,SccNumberList),
   	    findall(	(package,DependentID),
             		member([DependentID,_,SccNumber2,_],DepList),
             		PackageListWithDuplicates),	    
	    sort(PackageListWithDuplicates,Packages),
	    
	    length(Packages,Size),
	    not(Size = 1),

   	    findall(	(dependency,[DependentID, DependeeID]),
             		(
             			member([DependentID,DependeeID,SccNumber2,_],DepList),
             			not(DependentID = DependeeID)
             		),
             		DependencyListWithDuplicates),	    
	    sort(DependencyListWithDuplicates,Dependencies).
		


